# CONTRIBUTING

## Development Workflow

- Install `pyenv` and `pipenv` to manage `python` development/testing dependencies
  - <https://github.com/pyenv/pyenv#installation>
  - <https://github.com/pypa/pipenv#installation>
- Install `docker` and `docker-compose` (if you have not done so already)
- Make a new gitlab group for testing, (named whatever you like), with a project called "repoman-quickstart" inside it
- Generate a personal access token and place it in `~/.config/repoman/GITLAB_TOKEN` on your local machine
  - Alternately, create a test user, (with token), that only has access to your new Gitlab test group instead
- Place the url slug, (name as displayed in url), of your gitlab group in this variable assignment and run it in your shell
  - `export gitlab_group="put_your_gitlab_group_url_slug_here`
- `git clone https://gitlab.com/dreamer-labs/repoman/repoman.git` && \
  `cd repoman/ && \`
  `read -r python_version; pyenv install $python_version < ./.python-version && \`
  `read -r python_version; pipenv --python $python_version < ./.python-version && \`
  `pipenv install --dev && \`
  `cp -pR example-repoman-data/ repoman-data/ && \`
  `sed -i "s%placeholder%$gitlab_group%g" ./repoman-data/configs/config.yml.j2 && \`
  `sed -i "s%placeholder%$gitlab_group%g" ./repoman-data/configs/vars.yml && \`
  `./launch-repoman install`
- Install missing deps (if needed, and then rerun `./launch-repoman install` until installed)
- Once installed, run:
- `source ~/.config/repoman/bashrc && \`
  `launch-repoman devel`
- Make your changes/additions
  - Read docs in `docs/` to understand component integrations and where to put your code (if needed)
  - Read `Feature Tour` to better understand existing features (if needed)
  - exit
- `launch-repoman local`
- `repoman function`; where "function" is the one you changed/added
- If function works: write your tests in `tests/`; use previous tests as examples
  - If not, relaunch-repoman dev environment and fix issues; run tests again until successful
- `launch-repoman test_all`
- Install any missing test deps and fix any failed tests
- `git add`, `git commit`, and then run: `repoman test_all`
- If the test-logs commit is properly generated: `git push` to your fork (or branch)
- Submit MR
- Merge on approval

## Notes on tools

- Linting and autoformatting are performed automagically by `./tests/run_tests.sh`
  - `shellcheck` (configured with ./.shellcheckrc)
  - `shfmt` (configured with ./.editorconfig)
- Docs are autogenerated by `shdoc` on each test run too
- `pipenv` is used to show other devs what env conditions tests passed under on your local machine
- `pyenv` is used to lock the python version, so the same reason
- devs are encouraged to ensure tests pass under the latest available versions of python and all deps
  - When updating versions of deps or python, update the `Pipfile`, `Pipfile.lock` and `.python-version`
  - See `pipenv` docs for more details on how to update `Pipfile` and `Pipfile.lock`: <https://github.com/pypa/pipenv>
  - See `pyenv` docs for more details on how to update `.python-version` file: <https://github.com/pyenv/pyenv>

## Creating a new function - Hello World

- Follow the `Development Workflow` section instructions up to the step where you "Make your changes/additions"
- Create an ansible playbook at `src/container/etc-ansible/hello-world.yml`
  - Ensure the playbook runs against `localhost` and uses the `file` or `shell` module to print "Hello World" to a file
  - Ensure the file path is `/etc/repoman/tempdir/hello-world.txt`
  - See existing playbooks and follow the same style conventions
- Open `src/repoman-launcher.sh`, and add logic to the case statement for a `hello-world` function
- When users provide `hello-world` as `$1` to `repoman-launcher.sh` it should trigger the `hello-world.yml` ansible playbook
- After adding `hello-world.yml` and modifying `repoman-launcher.sh`, `exit` the `repoman-devel` environment
- Navigate to `tests/` and `launch-repoman test_01` to see how the test framework operates
  - Compare the results to the files in `test_01/` and use it as an example for your test scenario
- Make a new test scenario by creating `test_99/bashtests/` directory and subdirectory
- For your bashtest, use `md5sum` to print the md5 checksum of `/etc/repoman/tempdir/hello-world.txt`
  - The `./mk-test.sh` helper script is provided to aid in test creation; see `docs/` for more details
  - It is **highly** recommended to use `./mk-test.sh` since `bashtest` is very sensitive to non-printed characters
- Copy the `test_01/fixtures/test_env.yml` into your scenario directory, and update it to execute your new repoman function
- Run `launch-repoman test_99` to execute your test
- Once passing, `hello-world` is complete!

## Test framework and strategy

- Repoman is primarily tested by performing integration tests of individual functions using `bashtest`
- Testing should avoid external dependencies like network connectivity, when possible
  - Rather than testing the ability to integrate with external service,
    test the ability of each function to generate configuration file or API calls that are known-good values
  - This strategy undoubtably will result in gaps in testing for certain functions,
    but will also reduce tests failing due to intermittent external service failures or dev env connectivity issues
  - The overall result *should* be more repeatable and reliable tests that work across mulitple dev environments
- Certain Repoman features are also tested using basic linting and syntax testing
  - Since Repoman's entrypoint components are written in `bash`, `shellcheck` is used to lint them
  - `shellcheck` and `shfmt` are great at catching egregious offenses against `bash` syntactic sugar
  - They also ensure the syntax is just correct enough to execute without obvious fatal errors
  - `mk-test.sh` is *only* covered under linting, not bashtests
- `entrypoint.sh` and `launch-repoman` are, (at least partly), covered by both types of testing
- For now, **no unit tests are performed** with things like `bats`, `shunit2`, `molecule`, et cetera
- For now, the "happy path" is well tested, but error handling is not as well tested for each function;
  this is by design to help us iterate quickly during repoman's early stages of development